package tools.descartes.dql.connector.kieker.structures.classes;

import tools.descartes.dql.connector.kieker.structures.AbstractCollectorMap;
import tools.descartes.dql.connector.kieker.structures.Trace;
import tools.descartes.dql.connector.kieker.structures.identifier.ComponentIdentifier;
import tools.descartes.dql.connector.kieker.structures.records.EventRecord;



public class ClassMap extends AbstractCollectorMap<ClassMapKey,ClassMapValue>{

	
	private static final long serialVersionUID = 3216493643960468738L;
	private static ClassMap instance;

	private ClassMap(){};
	
	public static synchronized ClassMap getInstance () {
		if (ClassMap.instance == null) {
			ClassMap.instance = new ClassMap();
		}
		return ClassMap.instance;
	}


	public synchronized ClassMapKey getKeyViaID(long id){

		for (Entry<ClassMapKey,ClassMapValue> entry : entrySet()) {
			if (entry.getValue().getID()==id) {
				return entry.getKey();
			}
		}
		return null;
	}



	@Override
	protected Object isUpdateValue(Object key, Object newValue) {
		return null;
	}

	@Override
	public void pushToTrace(Trace trace) {
		for (Entry<ClassMapKey, ClassMapValue> entry : ClassMap.getInstance().entrySet()) {
			String classID = entry.getKey().getClassID();
			String hostID = entry.getKey().getHostID();
			long timestamp = entry.getValue().getCurrentTimestamp();
			String requestID =  entry.getKey().getRequestID();
			trace.addEvent(new EventRecord(ComponentIdentifier.createClassComponentIdentifier(hostID,classID), timestamp, 0,requestID));
		}
	}

}
